xref: /linux/scripts/kconfig/Makefile (revision 022a4bf6b59dfdb192ca8aef291c7346f984e511)
1# SPDX-License-Identifier: GPL-2.0
2# ===========================================================================
3# Kernel configuration targets
4# These targets are used from top-level makefile
5
6PHONY += xconfig gconfig menuconfig config syncconfig update-po-config \
7	localmodconfig localyesconfig
8
9ifdef KBUILD_KCONFIG
10Kconfig := $(KBUILD_KCONFIG)
11else
12Kconfig := Kconfig
13endif
14
15ifeq ($(quiet),silent_)
16silent := -s
17endif
18
19# We need this, in case the user has it in its environment
20unexport CONFIG_
21
22xconfig: $(obj)/qconf
23	$< $(silent) $(Kconfig)
24
25gconfig: $(obj)/gconf
26	$< $(silent) $(Kconfig)
27
28menuconfig: $(obj)/mconf
29	$< $(silent) $(Kconfig)
30
31config: $(obj)/conf
32	$< $(silent) --oldaskconfig $(Kconfig)
33
34nconfig: $(obj)/nconf
35	$< $(silent) $(Kconfig)
36
37# This has become an internal implementation detail and is now deprecated
38# for external use.
39syncconfig: $(obj)/conf
40	$(Q)mkdir -p include/config include/generated
41	$(Q)test -e include/generated/autoksyms.h || \
42	    touch   include/generated/autoksyms.h
43	$< $(silent) --$@ $(Kconfig)
44
45localyesconfig localmodconfig: $(obj)/conf
46	$(Q)mkdir -p include/config include/generated
47	$(Q)perl $(srctree)/$(src)/streamline_config.pl --$@ $(srctree) $(Kconfig) > .tmp.config
48	$(Q)if [ -f .config ]; then 					\
49			cmp -s .tmp.config .config ||			\
50			(mv -f .config .config.old.1;			\
51			 mv -f .tmp.config .config;			\
52			 $< $(silent) --oldconfig $(Kconfig);		\
53			 mv -f .config.old.1 .config.old)		\
54	else								\
55			mv -f .tmp.config .config;			\
56			$< $(silent) --oldconfig $(Kconfig);		\
57	fi
58	$(Q)rm -f .tmp.config
59
60# Create new linux.pot file
61# Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files
62update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h
63	$(Q)$(kecho) "  GEN     config.pot"
64	$(Q)xgettext --default-domain=linux                         \
65	    --add-comments --keyword=_ --keyword=N_                 \
66	    --from-code=UTF-8                                       \
67	    --files-from=$(srctree)/scripts/kconfig/POTFILES.in     \
68	    --directory=$(srctree) --directory=$(objtree)           \
69	    --output $(obj)/config.pot
70	$(Q)sed -i s/CHARSET/UTF-8/ $(obj)/config.pot
71	$(Q)(for i in `ls $(srctree)/arch/*/Kconfig      \
72	    $(srctree)/arch/*/um/Kconfig`;               \
73	    do                                           \
74		$(kecho) "  GEN     $$i";                    \
75		$(obj)/kxgettext $$i                     \
76		     >> $(obj)/config.pot;               \
77	    done )
78	$(Q)$(kecho) "  GEN     linux.pot"
79	$(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \
80	    --output $(obj)/linux.pot
81	$(Q)rm -f $(obj)/config.pot
82
83# These targets map 1:1 to the commandline options of 'conf'
84simple-targets := oldconfig allnoconfig allyesconfig allmodconfig \
85	alldefconfig randconfig listnewconfig olddefconfig
86PHONY += $(simple-targets)
87
88$(simple-targets): $(obj)/conf
89	$< $(silent) --$@ $(Kconfig)
90
91PHONY += oldnoconfig silentoldconfig savedefconfig defconfig
92
93# oldnoconfig is an alias of olddefconfig, because people already are dependent
94# on its behavior (sets new symbols to their default value but not 'n') with the
95# counter-intuitive name.
96oldnoconfig: olddefconfig
97	@echo "  WARNING: \"oldnoconfig\" target will be removed after Linux 4.19"
98	@echo "            Please use \"olddefconfig\" instead, which is an alias."
99
100# We do not expect manual invokcation of "silentoldcofig" (or "syncconfig").
101silentoldconfig: syncconfig
102	@echo "  WARNING: \"silentoldconfig\" has been renamed to \"syncconfig\""
103	@echo "            and is now an internal implementation detail."
104	@echo "            What you want is probably \"oldconfig\"."
105	@echo "            \"silentoldconfig\" will be removed after Linux 4.19"
106
107savedefconfig: $(obj)/conf
108	$< $(silent) --$@=defconfig $(Kconfig)
109
110defconfig: $(obj)/conf
111ifeq ($(KBUILD_DEFCONFIG),)
112	$< $(silent) --defconfig $(Kconfig)
113else
114ifneq ($(wildcard $(srctree)/arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG)),)
115	@$(kecho) "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
116	$(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
117else
118	@$(kecho) "*** Default configuration is based on target '$(KBUILD_DEFCONFIG)'"
119	$(Q)$(MAKE) -f $(srctree)/Makefile $(KBUILD_DEFCONFIG)
120endif
121endif
122
123%_defconfig: $(obj)/conf
124	$(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig)
125
126configfiles=$(wildcard $(srctree)/kernel/configs/$@ $(srctree)/arch/$(SRCARCH)/configs/$@)
127
128%.config: $(obj)/conf
129	$(if $(call configfiles),, $(error No configuration exists for this target on this architecture))
130	$(Q)$(CONFIG_SHELL) $(srctree)/scripts/kconfig/merge_config.sh -m .config $(configfiles)
131	+$(Q)yes "" | $(MAKE) -f $(srctree)/Makefile oldconfig
132
133PHONY += kvmconfig
134kvmconfig: kvm_guest.config
135	@:
136
137PHONY += xenconfig
138xenconfig: xen.config
139	@:
140
141PHONY += tinyconfig
142tinyconfig:
143	$(Q)$(MAKE) -f $(srctree)/Makefile allnoconfig tiny.config
144
145# CHECK: -o cache_dir=<path> working?
146PHONY += testconfig
147testconfig: $(obj)/conf
148	$(PYTHON3) -B -m pytest $(srctree)/$(src)/tests \
149	-o cache_dir=$(abspath $(obj)/tests/.cache) \
150	$(if $(findstring 1,$(KBUILD_VERBOSE)),--capture=no)
151clean-dirs += tests/.cache
152
153# Help text used by make help
154help:
155	@echo  '  config	  - Update current config utilising a line-oriented program'
156	@echo  '  nconfig         - Update current config utilising a ncurses menu based'
157	@echo  '                    program'
158	@echo  '  menuconfig	  - Update current config utilising a menu based program'
159	@echo  '  xconfig	  - Update current config utilising a Qt based front-end'
160	@echo  '  gconfig	  - Update current config utilising a GTK+ based front-end'
161	@echo  '  oldconfig	  - Update current config utilising a provided .config as base'
162	@echo  '  localmodconfig  - Update current config disabling modules not loaded'
163	@echo  '  localyesconfig  - Update current config converting local mods to core'
164	@echo  '  defconfig	  - New config with default from ARCH supplied defconfig'
165	@echo  '  savedefconfig   - Save current config as ./defconfig (minimal config)'
166	@echo  '  allnoconfig	  - New config where all options are answered with no'
167	@echo  '  allyesconfig	  - New config where all options are accepted with yes'
168	@echo  '  allmodconfig	  - New config selecting modules when possible'
169	@echo  '  alldefconfig    - New config with all symbols set to default'
170	@echo  '  randconfig	  - New config with random answer to all options'
171	@echo  '  listnewconfig   - List new options'
172	@echo  '  olddefconfig	  - Same as oldconfig but sets new symbols to their'
173	@echo  '                    default value without prompting'
174	@echo  '  kvmconfig	  - Enable additional options for kvm guest kernel support'
175	@echo  '  xenconfig       - Enable additional options for xen dom0 and guest kernel support'
176	@echo  '  tinyconfig	  - Configure the tiniest possible kernel'
177
178# lxdialog stuff
179check-lxdialog  := $(srctree)/$(src)/lxdialog/check-lxdialog.sh
180
181# Use recursively expanded variables so we do not call gcc unless
182# we really need to do so. (Do not call gcc as part of make mrproper)
183HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags) \
184                    -DLOCALE
185
186# ===========================================================================
187# Shared Makefile for the various kconfig executables:
188# conf:	  Used for defconfig, oldconfig and related targets
189# nconf:  Used for the nconfig target.
190#         Utilizes ncurses
191# mconf:  Used for the menuconfig target
192#         Utilizes the lxdialog package
193# qconf:  Used for the xconfig target
194#         Based on Qt which needs to be installed to compile it
195# gconf:  Used for the gconfig target
196#         Based on GTK+ which needs to be installed to compile it
197# object files used by all kconfig flavours
198
199lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o
200lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o
201
202conf-objs	:= conf.o  zconf.tab.o
203mconf-objs     := mconf.o zconf.tab.o $(lxdialog)
204nconf-objs     := nconf.o zconf.tab.o nconf.gui.o
205kxgettext-objs	:= kxgettext.o zconf.tab.o
206qconf-cxxobjs	:= qconf.o
207qconf-objs	:= zconf.tab.o
208gconf-objs	:= gconf.o zconf.tab.o
209
210hostprogs-y := conf nconf mconf kxgettext qconf gconf
211
212targets		+= zconf.tab.c zconf.lex.c
213clean-files	:= qconf.moc .tmp_qtcheck .tmp_gtkcheck
214clean-files	+= zconf.tab.c zconf.lex.c gconf.glade.h
215clean-files     += config.pot linux.pot
216
217# Check that we have the required ncurses stuff installed for lxdialog (menuconfig)
218PHONY += $(obj)/dochecklxdialog
219$(addprefix $(obj)/, mconf.o $(lxdialog)): $(obj)/dochecklxdialog
220$(obj)/dochecklxdialog:
221	$(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOSTLOADLIBES_mconf)
222
223always := dochecklxdialog
224
225# Add environment specific flags
226HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS))
227HOST_EXTRACXXFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCXX) $(HOSTCXXFLAGS))
228
229# generated files seem to need this to find local include files
230HOSTCFLAGS_zconf.lex.o	:= -I$(src)
231HOSTCFLAGS_zconf.tab.o	:= -I$(src)
232
233HOSTLOADLIBES_qconf	= $(KC_QT_LIBS)
234HOSTCXXFLAGS_qconf.o	= $(KC_QT_CFLAGS)
235
236HOSTLOADLIBES_gconf	= `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0`
237HOSTCFLAGS_gconf.o	= `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \
238                          -Wno-missing-prototypes
239
240HOSTLOADLIBES_mconf   = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC))
241
242HOSTLOADLIBES_nconf	= $(shell \
243				pkg-config --libs menuw panelw ncursesw 2>/dev/null \
244				|| pkg-config --libs menu panel ncurses 2>/dev/null \
245				|| echo "-lmenu -lpanel -lncurses"  )
246$(obj)/qconf.o: $(obj)/.tmp_qtcheck
247
248ifeq ($(MAKECMDGOALS),xconfig)
249$(obj)/.tmp_qtcheck: $(src)/Makefile
250-include $(obj)/.tmp_qtcheck
251
252# Qt needs some extra effort...
253$(obj)/.tmp_qtcheck:
254	@set -e; $(kecho) "  CHECK   qt"; \
255	if pkg-config --exists Qt5Core; then \
256	    cflags="-std=c++11 -fPIC `pkg-config --cflags Qt5Core Qt5Gui Qt5Widgets`"; \
257	    libs=`pkg-config --libs Qt5Core Qt5Gui Qt5Widgets`; \
258	    moc=`pkg-config --variable=host_bins Qt5Core`/moc; \
259	elif pkg-config --exists QtCore; then \
260	    cflags=`pkg-config --cflags QtCore QtGui`; \
261	    libs=`pkg-config --libs QtCore QtGui`; \
262	    moc=`pkg-config --variable=moc_location QtCore`; \
263	else \
264	    echo >&2 "*"; \
265	    echo >&2 "* Could not find Qt via pkg-config."; \
266	    echo >&2 "* Please install either Qt 4.8 or 5.x. and make sure it's in PKG_CONFIG_PATH"; \
267	    echo >&2 "*"; \
268	    exit 1; \
269	fi; \
270	echo "KC_QT_CFLAGS=$$cflags" > $@; \
271	echo "KC_QT_LIBS=$$libs" >> $@; \
272	echo "KC_QT_MOC=$$moc" >> $@
273endif
274
275$(obj)/gconf.o: $(obj)/.tmp_gtkcheck
276
277ifeq ($(MAKECMDGOALS),gconfig)
278-include $(obj)/.tmp_gtkcheck
279
280# GTK+ needs some extra effort, too...
281$(obj)/.tmp_gtkcheck:
282	@if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then		\
283		if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then			\
284			touch $@;								\
285		else									\
286			echo >&2 "*"; 							\
287			echo >&2 "* GTK+ is present but version >= 2.0.0 is required.";	\
288			echo >&2 "*";							\
289			false;								\
290		fi									\
291	else										\
292		echo >&2 "*"; 								\
293		echo >&2 "* Unable to find the GTK+ installation. Please make sure that"; 	\
294		echo >&2 "* the GTK+ 2.0 development package is correctly installed..."; 	\
295		echo >&2 "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; 		\
296		echo >&2 "*"; 								\
297		false;									\
298	fi
299endif
300
301$(obj)/zconf.tab.o: $(obj)/zconf.lex.c
302
303$(obj)/qconf.o: $(obj)/qconf.moc
304
305quiet_cmd_moc = MOC     $@
306      cmd_moc = $(KC_QT_MOC) -i $< -o $@
307
308$(obj)/%.moc: $(src)/%.h $(obj)/.tmp_qtcheck
309	$(call cmd,moc)
310
311# Extract gconf menu items for i18n support
312$(obj)/gconf.glade.h: $(obj)/gconf.glade
313	$(Q)intltool-extract --type=gettext/glade --srcdir=$(srctree) \
314	$(obj)/gconf.glade
315